Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -8680,44 +8978,39 @@
  SUBROUTINE salsa_check_data_output( var, unit )
  
-    USE control_parameters,                                                    &
+    USE control_parameters,                                                                        &
         ONLY:  message_string
 
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  unit     !< 
-    CHARACTER (LEN=*) ::  var      !< 
+    CHARACTER(LEN=*) ::  unit     !<
+    CHARACTER(LEN=*) ::  var      !<
 
     SELECT CASE ( TRIM( var ) )
-          
-       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV',               &
-              'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4',  'N_bin5',  'N_bin6',    &
-              'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12',   &
-              'Ntot' )
+
+       CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV',  'g_OCSV', 'N_bin1', 'N_bin2', 'N_bin3',     &
+              'N_bin4',  'N_bin5',  'N_bin6', 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10', 'N_bin11',  &
+              'N_bin12', 'Ntot' )
           IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                       'res salsa = .TRUE.'
-             CALL message( 'check_parameters', 'SA0006', 1, 2, 0, 6, 0 )
+             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
+             CALL message( 'check_parameters', 'PA0645', 1, 2, 0, 6, 0 )
           ENDIF
           unit = '#/m3'
-          
+
        CASE ( 'LDSA' )
           IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                       'res salsa = .TRUE.'
-             CALL message( 'check_parameters', 'SA0003', 1, 2, 0, 6, 0 )
+             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
+             CALL message( 'check_parameters', 'PA0646', 1, 2, 0, 6, 0 )
           ENDIF
-          unit = 'mum2/cm3'          
-          
-       CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4',  'm_bin5',  'm_bin6',    &
-              'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12',   &
-              'PM2.5',  'PM10',   's_BC',   's_DU',    's_H2O',   's_NH',      &
-              's_NO',   's_OC',   's_SO4',  's_SS' )
+          unit = 'mum2/cm3'
+
+       CASE ( 'm_bin1', 'm_bin2',  'm_bin3',  'm_bin4',  'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
+              'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12', 'PM2.5',  'PM10',   's_BC',   's_DU',     &
+              's_H2O',  's_NH',    's_NO',    's_OC',    's_SO4',  's_SS' )
           IF (  .NOT.  salsa )  THEN
-             message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                       'res salsa = .TRUE.'
-             CALL message( 'check_parameters', 'SA0001', 1, 2, 0, 6, 0 )
+             message_string = 'output of "' // TRIM( var ) // '" requires salsa = .TRUE.'
+             CALL message( 'check_parameters', 'PA0647', 1, 2, 0, 6, 0 )
           ENDIF
           unit = 'kg/m3'
-             
+
        CASE DEFAULT
           unit = 'illegal'
@@ -8726,5 +9019,5 @@
 
  END SUBROUTINE salsa_check_data_output
- 
+
 !------------------------------------------------------------------------------!
 !
@@ -8734,5 +9027,4 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE salsa_3d_data_averaging( mode, variable )
- 
 
     USE control_parameters
@@ -8744,23 +9036,23 @@
     IMPLICIT NONE
 
-    CHARACTER (LEN=*) ::  mode       !< 
-    CHARACTER (LEN=*) ::  variable   !< 
-
-    INTEGER(iwp) ::  b   !<     
-    INTEGER(iwp) ::  c   !<
-    INTEGER(iwp) ::  i   !<
-    INTEGER(iwp) ::  icc !<
-    INTEGER(iwp) ::  j   !< 
-    INTEGER(iwp) ::  k   !< 
-    
-    REAL(wp) ::  df       !< For calculating LDSA: fraction of particles 
-                          !< depositing in the alveolar (or tracheobronchial)
-                          !< region of the lung. Depends on the particle size 
+    CHARACTER(LEN=*)  ::  mode       !<
+    CHARACTER(LEN=10) ::  vari       !<
+    CHARACTER(LEN=*)  ::  variable   !<
+
+    INTEGER(iwp) ::  found_index  !<
+    INTEGER(iwp) ::  i            !<
+    INTEGER(iwp) ::  ib           !<
+    INTEGER(iwp) ::  ic           !<
+    INTEGER(iwp) ::  j            !<
+    INTEGER(iwp) ::  k            !<
+
+    REAL(wp) ::  df       !< For calculating LDSA: fraction of particles depositing in the alveolar
+                          !< (or tracheobronchial) region of the lung. Depends on the particle size
     REAL(wp) ::  mean_d   !< Particle diameter in micrometres
     REAL(wp) ::  nc       !< Particle number concentration in units 1/cm**3
-    REAL(wp) ::  temp_bin !<
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< points to 
-                                                     !< selected output variable
-    
+    REAL(wp) ::  temp_bin !< temporary variable
+
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< points to selected output variable
+
     temp_bin = 0.0_wp
 
@@ -8768,121 +9060,121 @@
 
        SELECT CASE ( TRIM( variable ) )
-       
+
           CASE ( 'g_H2SO4' )
-             IF ( .NOT. ALLOCATED( g_H2SO4_av ) )  THEN
-                ALLOCATE( g_H2SO4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( g_h2so4_av ) )  THEN
+                ALLOCATE( g_h2so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             g_H2SO4_av = 0.0_wp
-             
+             g_h2so4_av = 0.0_wp
+
           CASE ( 'g_HNO3' )
-             IF ( .NOT. ALLOCATED( g_HNO3_av ) )  THEN
-                ALLOCATE( g_HNO3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( g_hno3_av ) )  THEN
+                ALLOCATE( g_hno3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             g_HNO3_av = 0.0_wp
-             
+             g_hno3_av = 0.0_wp
+
           CASE ( 'g_NH3' )
-             IF ( .NOT. ALLOCATED( g_NH3_av ) )  THEN
-                ALLOCATE( g_NH3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( g_nh3_av ) )  THEN
+                ALLOCATE( g_nh3_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             g_NH3_av = 0.0_wp
-             
+             g_nh3_av = 0.0_wp
+
           CASE ( 'g_OCNV' )
-             IF ( .NOT. ALLOCATED( g_OCNV_av ) )  THEN
-                ALLOCATE( g_OCNV_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( g_ocnv_av ) )  THEN
+                ALLOCATE( g_ocnv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             g_OCNV_av = 0.0_wp
-             
+             g_ocnv_av = 0.0_wp
+
           CASE ( 'g_OCSV' )
-             IF ( .NOT. ALLOCATED( g_OCSV_av ) )  THEN
-                ALLOCATE( g_OCSV_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( g_ocsv_av ) )  THEN
+                ALLOCATE( g_ocsv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             g_OCSV_av = 0.0_wp             
-             
+             g_ocsv_av = 0.0_wp
+
           CASE ( 'LDSA' )
-             IF ( .NOT. ALLOCATED( LDSA_av ) )  THEN
-                ALLOCATE( LDSA_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( ldsa_av ) )  THEN
+                ALLOCATE( ldsa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             LDSA_av = 0.0_wp
-             
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6',   &
-                 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
-             IF ( .NOT. ALLOCATED( Nbins_av ) )  THEN
-                ALLOCATE( Nbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins) )
+             ldsa_av = 0.0_wp
+
+          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
+                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
+             IF ( .NOT. ALLOCATED( nbins_av ) )  THEN
+                ALLOCATE( nbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
              ENDIF
-             Nbins_av = 0.0_wp
-             
+             nbins_av = 0.0_wp
+
           CASE ( 'Ntot' )
-             IF ( .NOT. ALLOCATED( Ntot_av ) )  THEN
-                ALLOCATE( Ntot_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( ntot_av ) )  THEN
+                ALLOCATE( ntot_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             Ntot_av = 0.0_wp
-             
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6',   &
-                 'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
+             ntot_av = 0.0_wp
+
+          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
+                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
              IF ( .NOT. ALLOCATED( mbins_av ) )  THEN
-                ALLOCATE( mbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins) )
+                ALLOCATE( mbins_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
              ENDIF
              mbins_av = 0.0_wp
-             
+
           CASE ( 'PM2.5' )
-             IF ( .NOT. ALLOCATED( PM25_av ) )  THEN
-                ALLOCATE( PM25_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( pm25_av ) )  THEN
+                ALLOCATE( pm25_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             PM25_av = 0.0_wp
-             
+             pm25_av = 0.0_wp
+
           CASE ( 'PM10' )
-             IF ( .NOT. ALLOCATED( PM10_av ) )  THEN
-                ALLOCATE( PM10_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( pm10_av ) )  THEN
+                ALLOCATE( pm10_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             PM10_av = 0.0_wp
-             
+             pm10_av = 0.0_wp
+
           CASE ( 's_BC' )
-             IF ( .NOT. ALLOCATED( s_BC_av ) )  THEN
-                ALLOCATE( s_BC_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_bc_av ) )  THEN
+                ALLOCATE( s_bc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_BC_av = 0.0_wp
-          
+             s_bc_av = 0.0_wp
+
           CASE ( 's_DU' )
-             IF ( .NOT. ALLOCATED( s_DU_av ) )  THEN
-                ALLOCATE( s_DU_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_du_av ) )  THEN
+                ALLOCATE( s_du_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_DU_av = 0.0_wp
-             
+             s_du_av = 0.0_wp
+
           CASE ( 's_H2O' )
-             IF ( .NOT. ALLOCATED( s_H2O_av ) )  THEN
-                ALLOCATE( s_H2O_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_h2o_av ) )  THEN
+                ALLOCATE( s_h2o_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_H2O_av = 0.0_wp
-             
+             s_h2o_av = 0.0_wp
+
           CASE ( 's_NH' )
-             IF ( .NOT. ALLOCATED( s_NH_av ) )  THEN
-                ALLOCATE( s_NH_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_nh_av ) )  THEN
+                ALLOCATE( s_nh_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_NH_av = 0.0_wp
-             
+             s_nh_av = 0.0_wp
+
           CASE ( 's_NO' )
-             IF ( .NOT. ALLOCATED( s_NO_av ) )  THEN
-                ALLOCATE( s_NO_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_no_av ) )  THEN
+                ALLOCATE( s_no_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_NO_av = 0.0_wp
-             
+             s_no_av = 0.0_wp
+
           CASE ( 's_OC' )
-             IF ( .NOT. ALLOCATED( s_OC_av ) )  THEN
-                ALLOCATE( s_OC_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_oc_av ) )  THEN
+                ALLOCATE( s_oc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_OC_av = 0.0_wp
-             
+             s_oc_av = 0.0_wp
+
           CASE ( 's_SO4' )
-             IF ( .NOT. ALLOCATED( s_SO4_av ) )  THEN
-                ALLOCATE( s_SO4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_so4_av ) )  THEN
+                ALLOCATE( s_so4_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_SO4_av = 0.0_wp   
-          
+             s_so4_av = 0.0_wp   
+
           CASE ( 's_SS' )
-             IF ( .NOT. ALLOCATED( s_SS_av ) )  THEN
-                ALLOCATE( s_SS_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             IF ( .NOT. ALLOCATED( s_ss_av ) )  THEN
+                ALLOCATE( s_ss_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
              ENDIF
-             s_SS_av = 0.0_wp
-          
+             s_ss_av = 0.0_wp
+
           CASE DEFAULT
              CONTINUE
@@ -8893,31 +9185,42 @@
 
        SELECT CASE ( TRIM( variable ) )
-       
+
           CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
-             IF ( TRIM( variable(3:) ) == 'H2SO4' )  THEN
-                icc = 1
-                to_be_resorted => g_H2SO4_av
-             ELSEIF ( TRIM( variable(3:) ) == 'HNO3' )  THEN
-                icc = 2
-                to_be_resorted => g_HNO3_av   
-             ELSEIF ( TRIM( variable(3:) ) == 'NH3' )  THEN
-                icc = 3
-                to_be_resorted => g_NH3_av   
-             ELSEIF ( TRIM( variable(3:) ) == 'OCNV' )  THEN
-                icc = 4
-                to_be_resorted => g_OCNV_av   
-             ELSEIF ( TRIM( variable(3:) ) == 'OCSV' )  THEN
-                icc = 5
-                to_be_resorted => g_OCSV_av        
-             ENDIF
+
+             vari = TRIM( variable(3:) )
+
+             SELECT CASE( vari )
+
+                CASE( 'H2SO4' )
+                   found_index = 1
+                   to_be_resorted => g_h2so4_av
+
+                CASE( 'HNO3' )
+                   found_index = 2
+                   to_be_resorted => g_hno3_av
+
+                CASE( 'NH3' )
+                   found_index = 3
+                   to_be_resorted => g_nh3_av
+
+                CASE( 'OCNV' )
+                   found_index = 4
+                   to_be_resorted => g_ocnv_av
+
+                CASE( 'OCSN' )
+                   found_index = 5
+                   to_be_resorted => g_ocsv_av
+
+             END SELECT
+
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +         &
-                                              salsa_gas(icc)%conc(k,j,i)
+                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                              &
+                                              salsa_gas(found_index)%conc(k,j,i)
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           CASE ( 'LDSA' )
              DO  i = nxlg, nxrg
@@ -8925,60 +9228,56 @@
                    DO  k = nzb, nzt+1
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins 
-!                      
+                      DO  ib = 1, nbins_aerosol
+!
 !--                      Diameter in micrometres
-                         mean_d = 1.0E+6_wp * Ra_dry(k,j,i,b) * 2.0_wp
-!                               
-!--                      Deposition factor: alveolar (use Ra_dry)                              
-                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp *     &
-                                ( LOG( mean_d ) + 2.84_wp )**2.0_wp )          &
-                                  + 19.11_wp * EXP( -0.482_wp *                &
-                                  ( LOG( mean_d ) - 1.362_wp )**2.0_wp ) )
-!                                    
+                         mean_d = 1.0E+6_wp * ra_dry(k,j,i,ib) * 2.0_wp
+!
+!--                      Deposition factor: alveolar (use ra_dry)
+                         df = ( 0.01555_wp / mean_d ) * ( EXP( -0.416_wp * ( LOG( mean_d ) +       &
+                                2.84_wp )**2 ) + 19.11_wp * EXP( -0.482_wp * ( LOG( mean_d ) -     &
+                                1.362_wp )**2 ) )
+!
 !--                      Number concentration in 1/cm3
-                         nc = 1.0E-6_wp * aerosol_number(b)%conc(k,j,i)    
-!                         
-!--                      Lung-deposited surface area LDSA (units mum2/cm3)                            
-                         temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc
+                         nc = 1.0E-6_wp * aerosol_number(ib)%conc(k,j,i)
+!
+!--                      Lung-deposited surface area LDSA (units mum2/cm3)
+                         temp_bin = temp_bin + pi * mean_d**2 * df * nc
                       ENDDO
-                      LDSA_av(k,j,i) = LDSA_av(k,j,i) + temp_bin
+                      ldsa_av(k,j,i) = ldsa_av(k,j,i) + temp_bin
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6',   &
-                 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
+
+          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
+                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  b = 1, nbins 
-                         Nbins_av(k,j,i,b) = Nbins_av(k,j,i,b) +               &
-                                             aerosol_number(b)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) + aerosol_number(ib)%conc(k,j,i)
                       ENDDO
                    ENDDO
                 ENDDO
              ENDDO
-          
+
           CASE ( 'Ntot' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  b = 1, nbins 
-                         Ntot_av(k,j,i) = Ntot_av(k,j,i) +                     &
-                                          aerosol_number(b)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         ntot_av(k,j,i) = ntot_av(k,j,i) + aerosol_number(ib)%conc(k,j,i)
                       ENDDO
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6',   &
-                 'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
+
+          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
+                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  b = 1, nbins 
-                         DO  c = b, nbins*ncc_tot, nbins
-                            mbins_av(k,j,i,b) = mbins_av(k,j,i,b) +            &
-                                                aerosol_mass(c)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         DO  ic = ib, nbins_aerosol * ncomponents_mass, nbins_aerosol
+                            mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) + aerosol_mass(ic)%conc(k,j,i)
                          ENDDO
                       ENDDO
@@ -8986,5 +9285,5 @@
                 ENDDO
              ENDDO
-             
+
           CASE ( 'PM2.5' )
              DO  i = nxlg, nxrg
@@ -8992,16 +9291,16 @@
                    DO  k = nzb, nzt+1
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 2.5E-6_wp )  THEN
-                            DO  c = b, nbins*ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 2.5E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
                          ENDIF
                       ENDDO
-                      PM25_av(k,j,i) = PM25_av(k,j,i) + temp_bin
+                      pm25_av(k,j,i) = pm25_av(k,j,i) + temp_bin
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           CASE ( 'PM10' )
              DO  i = nxlg, nxrg
@@ -9009,33 +9308,32 @@
                    DO  k = nzb, nzt+1
                       temp_bin = 0.0_wp
-                      DO  b = 1, nbins
-                         IF ( 2.0_wp * Ra_dry(k,j,i,b) <= 10.0E-6_wp )  THEN
-                            DO  c = b, nbins*ncc, nbins
-                               temp_bin = temp_bin + aerosol_mass(c)%conc(k,j,i)
+                      DO  ib = 1, nbins_aerosol
+                         IF ( 2.0_wp * ra_dry(k,j,i,ib) <= 10.0E-6_wp )  THEN
+                            DO  ic = ib, nbins_aerosol * ncc, nbins_aerosol
+                               temp_bin = temp_bin + aerosol_mass(ic)%conc(k,j,i)
                             ENDDO
                          ENDIF
                       ENDDO
-                      PM10_av(k,j,i) = PM10_av(k,j,i) + temp_bin
+                      pm10_av(k,j,i) = pm10_av(k,j,i) + temp_bin
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4',     &
-                 's_SS' )
+
+          CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
              IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                icc = get_index( prtcl, TRIM( variable(3:) ) )
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av       
+                found_index = get_index( prtcl, TRIM( variable(3:) ) )
+                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
+                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
+                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
+                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
+                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
+                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         DO  c = ( icc-1 )*nbins+1, icc*nbins 
-                            to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +    &
-                                                    aerosol_mass(c)%conc(k,j,i)
+                         DO  ic = ( found_index-1 ) * nbins_aerosol + 1, found_index * nbins_aerosol
+                            to_be_resorted(k,j,i) = to_be_resorted(k,j,i) +                        &
+                                                    aerosol_mass(ic)%conc(k,j,i)
                          ENDDO
                       ENDDO
@@ -9043,5 +9341,5 @@
                 ENDDO
              ENDIF
-             
+
           CASE DEFAULT
              CONTINUE
@@ -9052,73 +9350,70 @@
 
        SELECT CASE ( TRIM( variable ) )
-       
+
           CASE ( 'g_H2SO4', 'g_HNO3', 'g_NH3', 'g_OCNV', 'g_OCSV' )
              IF ( TRIM( variable(3:) ) == 'H2SO4' )  THEN
-                icc = 1
-                to_be_resorted => g_H2SO4_av
+                found_index = 1
+                to_be_resorted => g_h2so4_av
              ELSEIF ( TRIM( variable(3:) ) == 'HNO3' )  THEN
-                icc = 2
-                to_be_resorted => g_HNO3_av   
+                found_index = 2
+                to_be_resorted => g_hno3_av
              ELSEIF ( TRIM( variable(3:) ) == 'NH3' )  THEN
-                icc = 3
-                to_be_resorted => g_NH3_av   
+                found_index = 3
+                to_be_resorted => g_nh3_av
              ELSEIF ( TRIM( variable(3:) ) == 'OCNV' )  THEN
-                icc = 4
-                to_be_resorted => g_OCNV_av   
+                found_index = 4
+                to_be_resorted => g_ocnv_av
              ELSEIF ( TRIM( variable(3:) ) == 'OCSV' )  THEN
-                icc = 5
-                to_be_resorted => g_OCSV_av        
+                found_index = 5
+                to_be_resorted => g_ocsv_av
              ENDIF
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i)            &
-                                             / REAL( average_count_3d, KIND=wp )
+                      to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                              &
+                                              REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           CASE ( 'LDSA' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      LDSA_av(k,j,i) = LDSA_av(k,j,i)                          &
-                                        / REAL( average_count_3d, KIND=wp )
+                      ldsa_av(k,j,i) = ldsa_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6',   &
-                 'N_bin7', 'N_bin8', 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
+
+          CASE ( 'N_bin1', 'N_bin2', 'N_bin3', 'N_bin4', 'N_bin5', 'N_bin6', 'N_bin7', 'N_bin8',   &
+                 'N_bin9', 'N_bin10', 'N_bin11', 'N_bin12' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  b = 1, nbins 
-                         Nbins_av(k,j,i,b) = Nbins_av(k,j,i,b)                 &
-                                             / REAL( average_count_3d, KIND=wp )
+                      DO  ib = 1, nbins_aerosol
+                         nbins_av(k,j,i,ib) = nbins_av(k,j,i,ib) / REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           CASE ( 'Ntot' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      Ntot_av(k,j,i) = Ntot_av(k,j,i)                          &
-                                        / REAL( average_count_3d, KIND=wp )
+                      ntot_av(k,j,i) = ntot_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6',   &
-                 'm_bin7', 'm_bin8', 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
+
+          CASE ( 'm_bin1', 'm_bin2', 'm_bin3', 'm_bin4', 'm_bin5', 'm_bin6', 'm_bin7', 'm_bin8',   &
+                 'm_bin9', 'm_bin10', 'm_bin11', 'm_bin12' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      DO  b = 1, nbins 
-                         DO  c = b, nbins*ncc, nbins
-                            mbins_av(k,j,i,b) = mbins_av(k,j,i,b)              &
-                                             / REAL( average_count_3d, KIND=wp )
+                      DO  ib = 1, nbins_aerosol
+                         DO  ic = ib, nbins_aerosol * ncomponents_mass, nbins_aerosol
+                            mbins_av(k,j,i,ib) = mbins_av(k,j,i,ib) /                              &
+                                                 REAL( average_count_3d, KIND=wp)
                          ENDDO
                       ENDDO
@@ -9126,40 +9421,37 @@
                 ENDDO
              ENDDO
-             
+
           CASE ( 'PM2.5' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      PM25_av(k,j,i) = PM25_av(k,j,i) /                        &
-                                       REAL( average_count_3d, KIND=wp )
+                      pm25_av(k,j,i) = pm25_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-             
+
           CASE ( 'PM10' )
              DO  i = nxlg, nxrg
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      PM10_av(k,j,i) = PM10_av(k,j,i) /                        &
-                                       REAL( average_count_3d, KIND=wp )
+                      pm10_av(k,j,i) = pm10_av(k,j,i) / REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
              ENDDO
-             
-          CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4',     &
-                 's_SS' )
+
+          CASE ( 's_BC', 's_DU', 's_H2O', 's_NH', 's_NO', 's_OC', 's_SO4', 's_SS' )
              IF ( is_used( prtcl, TRIM( variable(3:) ) ) )  THEN
-                icc = get_index( prtcl, TRIM( variable(3:) ) )
-                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_BC_av
-                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_DU_av   
-                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_NH_av   
-                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_NO_av   
-                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_OC_av   
-                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_SO4_av   
-                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_SS_av 
+                found_index = get_index( prtcl, TRIM( variable(3:) ) )
+                IF ( TRIM( variable(3:) ) == 'BC' )   to_be_resorted => s_bc_av
+                IF ( TRIM( variable(3:) ) == 'DU' )   to_be_resorted => s_du_av
+                IF ( TRIM( variable(3:) ) == 'NH' )   to_be_resorted => s_nh_av
+                IF ( TRIM( variable(3:) ) == 'NO' )   to_be_resorted => s_no_av
+                IF ( TRIM( variable(3:) ) == 'OC' )   to_be_resorted => s_oc_av
+                IF ( TRIM( variable(3:) ) == 'SO4' )  to_be_resorted => s_so4_av
+                IF ( TRIM( variable(3:) ) == 'SS' )   to_be_resorted => s_ss_av 
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /       &
+                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /                           &
                                                  REAL( average_count_3d, KIND=wp )
                       ENDDO
